"""ID3 tags (mp3 song info) manipulation."""

import time
import string
import ID3
from playlist import pl

class Id3:
    def clear(self, files):
        """Clear each file's id3 title tag."""

        for fn in files:
            f = ID3.ID3(fn)
            f.title = ""
            f.write()


    def set_artist_title(self, files):
        """Set artist and title tag for each file."""

        artist = ui.ask("Artist: ")
        album = ui.ask("Album: ")
        for fn in files:
            f = ID3.ID3(fn)
            f.artist = artist
            f.album = album
            f.write()


    def info(self):
        import ui
        ui.do_clear = 1
        fname = pl.track.path
        try:
            f = ID3.ID3(fname)
        except:
            txt = '''
            Error reading ID3 tags.
            path:       %s
            name:       %s
            ''' % (fname, repr(pl.track.name))
        else:
            self.artist = f.artist
            self.album = f.album
            self.title = f.title
            valid_chars = string.printable[:95]
            for n in 'artist album title'.split():
                val = self.__dict__[n]
                nval = ''
                if val:
                    for c in val:
                        if c in valid_chars:
                            nval += c
                    self.__dict__[n] = nval

            txt = """
            artist:     %s
            album:      %s
            title:      %s
            path:       %s
            """ % (self.artist, self.album, self.title, fname)
        ui.fsdisplay(txt)


    def set_title(self, fn):
        """Set id3 title for this file."""

        f = ID3.ID3(fn)
        f.title = ui.ask("Title: ")
        f.write()


    def set_all(self, fn):
        """Set all id3 fields for the file."""

        fields = "title artist album comment year genre".split()
        f = ID3.ID3(fn)
        for field in fields:
            value = raw_input(field.capitalize() + ": ")
            exec "f.%s = '%s'" % (field, value)

id3 = Id3()
