import os
import ui
import shutil
import avkutil
import main
from status import stat
from scores import scores
from stats import stats
from data import data
from playlist import pl


def rmdir():
    path = pl.album.path
    if ui.ask("Delete current directory %s FROM DISK? (y/n)" % path) == 'y':
        shutil.rmtree(path)
        stat.normal('Current dir deleted from disk.')
    else:
        stat.normal('Dir not deleted.')


# TODO fix lyrics and images in NV
#def lyrics():
#    track = self.list[self.index]
#    l = glob.glob(os.path.split(track)[0] + "/*\.[tT][xX][tT]")
#    lyr = ""
#    if os.path.exists(track[:-3] + "txt"):
#        lyr = track[:-3] + "txt"
#    elif os.path.exists(track[:-3] + "TXT"):
#        lyr = track[:-3] + "TXT"
#    elif l:
#        lyr = l[0]
#    if lyr: 
#        os.system(text_viewer + ' "' + lyr + '"')
#    else: 
#        self.clear_line()
#        print "\rNo text files found."
#
#def images():
#    track = self.list[self.index]
#    dir = os.path.split(track)[0]
#    l = glob.glob(dir + "/*\.[jJ][pP][gG]")
#    l.extend(glob.glob(dir + "/*\.[jJ][pP][eE][gG]"))
#    l = [re.escape(x) for x in l]
#    l = ' '.join(l)
#    if l:
#        os.system(image_viewer + ' ' + l)
#    else:
#        self.clear_line()
#        print "\rNo images found."
#
#def lyrics_or_images():
#    """Return image or lyrics status.
#
#    If there are images and lyrics, return [li] status.
#    """
#
#    text = ""
#    track = playlist.current
#    l = os.listdir(track.dir)
#    for f in l:
#        if f.lower().endswith(".txt"):
#            text += 't'
#            break
#    for f in l:
#        e = f.lower().endswith
#        if e(".jpg") or e(".jpeg"):
#            text += 'i'
#            break
#
#    if text: 
#        return "[%s]" % text
#    else: 
#        return ""
#


def delete():
    """ Delete current track from disk."""
    path = pl.track.path
    ai, i = pl.albumindex, pl.index
    try:
        os.remove(os.path.join(os.getcwd(), path))
    except:
        stat.error('Error removing ' + path)
        return
    if data.random == 'queue':
        pl.albums[ai].remove(i)
        pl.next()
        return

    if i+1 >= len(pl.album):
        # if we don't go to next album beforehand, removing current track will
        # result in pl.index pointing out of bounds of current album
        pl.next_album()
        pl.albums[ai].remove(i)
    else:
        pl.albums[ai].remove(i)
        pl.update()
        from player import player
        player.play()


def favcd():
    """Create a dir with favorite tracks.

    Tracks are copied to the dir to be burned on a cd. User will be
    asked for the destination dir, cd size, bitrate limit.
    """

    ui.doredraw=0
    dest_dir = ui.ask("Directory to copy files to: ")
    if not dest_dir: 
        return
    if not os.path.exists(dest_dir):
        try: 
            os.mkdir(dest_dir)
        except OSError:
            print "Can't create dir - check permissions?"
            return
    answer = ui.ask(""" Choose cd size: 1) 650MB 2) 700MB 3) 2GB > """)
    if answer == '1'  : 
        cd_size = 650
    elif answer == '2': 
        cd_size = 700
    elif answer == '3': 
        cd_size = 2000
    answer = ui.ask(""" Bitrates: 1) Up to 128kbps 2) Up to 192kbps 3) All > """)
    if answer == "1"  : 
        bitrates = 128
    elif answer == "2": 
        bitrates = 192
    elif answer == "3": 
        bitrates = None
    only_mp3s = 0
    ui.doredraw = 0
    if ui.ask("Only mp3s? (y/n) ") == 'y':
        only_mp3s = 1
    stat.normal("Making list of files.. ")
    tracks = []                             # score, track list
    for album in pl.albums:
        for track in album.tracks:
            score = track.score()
            tracks.append((score, track))
    tracks.sort()
    stat.normal("done")
    stat.normal("Copying, this may take a few minutes.. ")
    size_limit = cd_size * 1024 * 1024      # mb to bytes
    while 1:
        if not tracks: break
        score, track = tracks.pop()
        if track.codec == "mp3":
            if only_mp3s:
                continue
            elif bitrates:
                track.info()
                if track.bitrate > bitrates:
                    continue
        track_size = os.stat(track.path)[6]
        size_limit -= track_size
        if size_limit >= 0:
            ui.display(track.fname)
            try: 
                shutil.copy(track.path, dest_dir)
            except OSError:
                stat.error( "Can't copy file - check permissions, drive space.")
                return
        else:
            break
    ui.display("done.")
    ui.doredraw=1


def volup():
    avkutil.vol("+5")
    main.vol = avkutil.vol()
    stat.normal("volume = " + main.vol)

def voldown():
    avkutil.vol("-5")
    main.vol = avkutil.vol()
    stat.normal("volume = " + main.vol)
