import os
import time
import sys
import threading
import avkutil
import conf
from colors import colors
from status import stat
from log import log
from data import data
from debug import debug
import ui


avkutil.dbg = 1


class Poll(threading.Thread):
    def run(self):
        """ Start playing new track when needed."""
        from playlist import pl
        import rand
        import modes
        while 1:
            time.sleep(1)
            if player.pl and player.pl.isAlive() and (player.mode ==
                    'play'):
                pass
                '''This does not work well if real time is longer than
                that reported by mp3.py, which happens fairly often.
                Besides, this isn't very much needed because tracks
                mostly quiet down to the end AND this doesn't happen
                too often - unlike when you hit 'n' a few times.
                '''

                # this doesn't work when real track's time is longer
                # than what is reported by 
                #if player.total and (player.total - player.elapsed <=
                #            conf.fadeout):
                #    vol = player.fadeout()
                #    time.sleep(.5)  # make sure this thing don't start again
                #    if vol: avkutil.vol(vol)

            if player.do_quit: 
                return
            if player.pl and (not player.pl.isAlive()) and (player.mode ==
                'play'):
                for i in range(data.interval):
                    # interval (pause) between tracks
                    time.sleep(1)
                    if player.do_quit:
                        return
                if player.pl.isAlive() or player.mode != 'play':
                    continue
                # random no repeat mode
                if data.random_norepeat:
                    if data.randlist:
                        modes.no_repeat()
                    else:
                        # random playlist exhausted
                        if data.continuous:
                            rand.mk_randlist()
                            modes.no_repeat()
                        else:
                            player.stop()
                # random track mode
                elif data.random == "track":
                    rand.rand()
                # random dir mode
                elif data.random == "album" and pl.index+1 >= len(pl.album):
                    rand.random_album()
                elif data.random == "album":
                    pl.next()
                # random queue mode
                elif data.random == "queue":
                    ql = data.queue
                    if ql:
                        del ql[0]
                    rand.queue()
                    current = ql[0]
                    pl.update(current[1],current[2])
                    player.play()
                # play one track mode
                elif data.play == "track":
                    if data.continuous:
                        player.play()
                    else:
                        player.stop()
                # play one dir mode
                elif data.play == "dir":
                    if pl.index+1 >= len(pl.album):
                        pl.first()
                        if not data.continuous:
                            player.stop()
                    else:
                        pl.next()
                # play full playlist mode
                elif data.play == "playlist":
                    if (pl.albumindex+1 >= len(pl.albums)) and (pl.index+1 >=
                                len(pl.album)):
                        pl.first_album()
                        if not data.continuous:
                            player.stop()
                    else:
                        pl.next()
                ui.fullredraw()


class Player:
    """Borg design pattern (all instances share the same state). See
    ActiveState python cookbook for this recipe.
    """

    _shared = {}        # shared state (borg design pattern, see ActiveState Python 
    pl      = None      # Play instance
    elapsed = 0
    total   = 0
    paused  = 0
    do_quit = 0
    mode    = "stop"
    start   = None


    def __init__(self):
        self.__dict__ = self._shared

    def is_playing(self):
        if self.pl:
            return self.pl.isAlive()
        else:
            return None


    def play(self): 
        """Play current track."""
        from playlist import pl
        from stats import stats
        if pl.do_play:
            self.stop()
            #if not os.path.exists(pl.track.path):
            #    stat.error("Current track not found on disk!")
            #    return
            #if os.stat(pl.track.path)[6] == 0:
            #    stat.error('mp3 file size is 0')
            self.start = time.time()
            self.pl = Play(pl.track, self)
            self.pl.start()
            stats.tracks_played += 1
            data.last_track = pl.track.fname
            try:
                fp = open(conf.current_song, 'w')
                fp.write(pl.track.name)
                fp.close()
            except:
                pass


    def fadeout(self):
        '''Do volume fadeout.'''
        if self.mode == 'play':
            if conf.fadeout:
                vol = avkutil.vol()
                step = (2*int(vol)/3) / (conf.fadeout*10)
                for i in range(conf.fadeout*10):
                    time.sleep(.1)
                    avkutil.vol('-%s' % step)
                return vol


    def stop(self):
        vol = None
        vol = self.fadeout()
        self.mode = "stop"
        if self.pl:
            self.pl.stop()
            for i in range(80):
                time.sleep(.1)
                if not self.pl.isAlive():
                    break
        if vol:
            avkutil.vol(vol)


    def pause(self):
        vol = None
        vol = self.fadeout()
        if self.pl and self.pl.isAlive():
            self.pl.pause = 1 - self.pl.pause   # toggle
            if self.pl.pause:
                self.mode = 'pause'
            else:
                self.mode = 'play'
        time.sleep(.3)
        if vol:
            avkutil.vol(vol)


    def play_stop(self):
        if self.mode == "play":
            self.stop()
            stat.normal("stop")
        else:
            self.play()
            stat.normal("play")


    def decode(self, tracks):
        """Decode mp3s to .wavs."""
        self.stop()
        for t in tracks:
            text = "decoding " + t
            os.system("mpg123 -w '%s.wav' '%s'" % (
                avkutil.split(t.fname)[0], t.fname))
            text += " done"
            ui.display(text)
        ui.display("All done")


    def progress(self):
        """Return current track's progress bar."""
        from playlist import pl
        t = pl.track
        if not os.path.exists(t.path):
            stat.error('Track %s not found' % t.fname)
            self.stop()
            return []
        total = "??:??"
        progress = ""
        self.elapsed = 0
        if self.pl:
            self.elapsed = self.pl.time
        #if self.mode == "play":
        #    self.elapsed = time.time() - (self.start + self.paused)
        #else:
        #    self.elapsed = 0
        m, s = self.elapsed / 60, self.elapsed % 60
        elapsed = [("%2d:%02d |" % (m, s), colors.default)]
        if t.codec == "mp3":
            if not t.secs:
                t.info()
            total = [("| %2d:%02d" % (t.mins, t.secs), colors.default)]
            self.total = t.total
            if not (self.elapsed and t.total):
                ratio = 0
            else:
                ratio = float(self.elapsed) / t.total 
        if stat.msg:
            progress = [(stat.msg, colors.default)]
        else:
            progress = self.progress_bar(ratio)
        return elapsed + progress + total


    def progress_bar(self, ratio, length=40, col=1, nocol="=."):
        """Text mode progress bar.

        ratio   - current position / total (e.g. 0.6 is 60%)
        length  - bar size
        col     - color bar
        nocol   - string, if default="=.", bar is [=======.....]
        """

        if ratio > 1:
            ratio = 1
        elchar, leftchar = nocol
        elapsed = int(round(ratio*length))
        left = length - elapsed
        bar = elchar*elapsed + leftchar*left
        bar = bar[:length]
        text = []
        if col:
            text.append((' '*elapsed, colors.progress))
            text.append((' '*left, colors.default))
        else:
            # TODO
            pass
        return text

    def rewind(self):
        if self.pl:
            self.pl.seek(ahead=0)

    def fforward(self):
        if self.pl:
            self.pl.seek()


class Play(threading.Thread):
    """Instantiate when ready to play a file:

    pl = Play(track)
    pl.start()          # start playing
    """

    def __init__(self, track, player):
        threading.Thread.__init__(self)
        self.path = track.path
        if track.codec == "mp3":
            self.command = conf.mp3prog
            if conf.audio_device:
                self.command += "-o " + conf.audio_device
        elif track.codec == "ogg":
            self.command = conf.oggprog
            if not conf.audio_device:
                self.command += "-doss"
            #else:
            #    self.command += "-d" + conf.device
        elif track.codec == "mod":
            self.command = conf.modprog
        self.player = self.command.split()[0]
        self.halt = 0
        self.player = player
        self.pause = 0
        self.time = 0


    def seek(self, ahead=1):
        if ahead:
            seek = 5
        else:
            seek = -5
        self.mf.seek_time(self.time*1000 + seek*1000)


    def run(self):
        import mad, ao
        self.mf = mad.MadFile(self.path)
        dev = ao.AudioDevice('oss', rate=self.mf.samplerate())
        global player
        player.mode = 'play'
        while 1:
            if self.halt:
                # manually halted, set mode to stop - to make sure poll won't
                # start a new song
                player.mode = 'stop'
                break
            if self.pause:
                time.sleep(0.1)
                continue
            buf = self.mf.read(500000)
            if buf is None:
                break
            dev.play(buf, len(buf))
            self.time = self.mf.current_time()/1000


    def stop(self):
        self.halt = 1


player = Player()
