"""Cymbaline score database management."""

import avkutil
from colors import colors
import conf
from data import data


class Scores:
    """Borg pattern - see ActiveState recipe."""

    _shared = {}    # shared state

    def __init__(self):
        self.__dict__ = self._shared
        self._dict = {}

    def load(self):
        self._dict = data.scores

    def save(self):
        data.scores = self._dict


    def score10(self):
        """Set current score to 75."""
        self.set(10, 1)

    def score75(self):
        """Set current score to 75."""
        self.set(75, 1)


    def set(self, score, absolute=1):
        """Change current track score.

        By default the change is relative, set absolute=1 for absolute.
        """

        from playlist import pl
        n = pl.track.fname.lower()
        if absolute: 
            s = score
        else: 
            if self._dict.has_key(n):
                s = self._dict[n]
            else:
                s = conf.def_score
            s += score
        if s > 100: s = 100
        elif s < 0: s = 0
        self._dict[n] = s
        if data.threshold:
            if self._dict[n] < data.threshold:
                pl.album.remove(pl.index)
                pl.update()
                # otherwise next() would skip one track
                pl.prev()


    def color_score(self, track):
        """Return bracketed colorized score."""
        s = track.score()
        color = colors.score_0_25
        if not s     : return ' '*5, color
        elif s <= 25 : color = colors.score_0_25
        elif s <= 50 : color = colors.score_25_50
        elif s <= 75 : color = colors.score_50_75
        else         : color = colors.score_75_100
        s = "%3d" % s
        return "[%s]" % s, color


scores = Scores()
